// Options
var scrollSpeed     = 3;
var scrollSnap      = 10;
var scrollImages	= new Array("chrome://autoscroll/content/autoscroll_all.png",
							    "chrome://autoscroll/content/autoscroll_v.png",
								"chrome://autoscroll/content/autoscroll_h.png");
var scrollCursor	= new Array("move", 
								"n-resize",
								"e-resize");
var clickOnly = false;

/////////////

var documentWidth;
var documentHeight;
var windowWidth;
var windowHeight;
var isScrolling = false;
var isIcon = false;
var hasScrolled = false;
var clientWnd = null;
var clientFrame = null;
var clientFrameDoc = null;
var clientFrameBody = null;
var startX;
var startY;
var clientX;
var clientY;
var snapOn;
var mouseDown = false;
var el;
var scrollCount = 0;

function autoScrollLoop() {
	if(isScrolling) {
		x = (clientX - startX) / scrollSpeed;
		y = (clientY - startY) / scrollSpeed;

		if(Math.abs(x) > 0 && Math.abs(y) > 0)
		{
			if(scrollCount++ % 2)
				y = 0;
			else
				x = 0;
		}

		clientFrame.scrollBy(x, y);
		setTimeout(autoScrollLoop, 5);
	}
}

function startScroll(evt) {
	startX = evt.clientX;
	startY = evt.clientY;
	clientFrame = evt.originalTarget.ownerDocument.defaultView;
	clientFrameDoc = evt.originalTarget.ownerDocument;
	clientFrameBody = (clientFrameDoc.getElementsByTagName('body')[0]) ? clientFrameDoc.getElementsByTagName('body')[0] : clientFrameDoc.getElementsByTagName('*')[0];
	clientWnd = evt.originalTarget.ownerDocument.contentWindow;

	isScrolling = true;
	hasScrolled = true;
	snapOn = true;

	insertAutoScrollMarker(evt);

	setTimeout(autoScrollLoop, 5);
}

function stopScroll(e) {
	isScrolling = false;
	removeAutoScrollMarker(e);
}

function isLink(node)
{
	if (!node)
		return false;
	else if (node.nodeName == "A" || node.nodeName == "INPUT" || node.nodeName == "TEXTAREA" || node.nodeName == "AREA")
		return true;
	else
		return isLink(node.parentNode);
}

function isChrome(target) {
        // Is there a better way to do this?
        if(target.id != "content")
                return true;
        else
                return false;
}

function isTabStrip(target) {
	// There must be a better way!
	if (target.nodeName == "tab" || target.nodeName.substr(0, 4) == "xul:" )
		return true;
	else
		return false;
}

function eventMouseDown(evt) {
	mouseDown = true;
	if(evt.button == "1" && !isScrolling && !isLink(evt.originalTarget) && !isChrome(evt.target) && !isTabStrip(evt.originalTarget))
		startScroll(evt);
	else if(hasScrolled)
		stopScroll(evt);
}

function eventMouseUp(evt) {
	mouseDown = false;
	if(!snapOn)
		stopScroll(evt);
}

function eventMouseMove(evt) {
	clientX = evt.clientX;
	clientY = evt.clientY;

	if (mouseDown && clickOnly && !snapOn)
		stopScroll(evt);

	if(isScrolling) {
		x = clientX - startX;
		y = clientY - startY;

		if((x > scrollSnap || x < -scrollSnap) || (y > scrollSnap || y < -scrollSnap))
			snapOn = false;
	}
}

/* 
	The following submitted by: Erik Arvidsson erik@eae.net 
	Slightly modified by: Matthew Ratzloff matt@kanchi.org
	http://www.mozdev.org/pipermail/autoscroll/2002-December/000002.html
*/
function insertAutoScrollMarker(e) {
	var docBox = clientFrameDoc.getBoxObjectFor(clientFrameDoc.documentElement);
	var left = e.screenX - docBox.screenX;
	var top = e.screenY - docBox.screenY;
	
	documentWidth = docBox.width;
	documentHeight = docBox.height;
	windowWidth = window.innerWidth;
	windowHeight = window.innerHeight;
	var imageWidth = 30;
	var imageHeight = 30;

	// overlay
	el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
	el.style.position = "fixed";
	el.style.left = "0px";
	el.style.top = "0px";
	el.style.width = documentWidth + "px";
	el.style.height = documentHeight + "px";
	el.style.cursor = scrollCursor[scrollType()];

	clientFrameBody.appendChild(el);
	_overlayContainer = el;

	// marker
	el = clientFrameDoc.createElementNS("http://www.w3.org/1999/xhtml", "img");
	el.src = scrollImages[scrollType()];

	el.style.position = "fixed";
	el.style.left = left - imageWidth / 2 + "px";
	el.style.top = top - imageHeight / 2 + "px";
	el.style.width = imageWidth + "px";
	el.style.height = imageHeight + "px";
	el.style.cursor = scrollCursor[scrollType()];

	clientFrameBody.appendChild(el);

	_autoScrollMarkerImage = el;
}

function scrollType() {
	if(windowHeight < documentHeight && windowWidth >= documentWidth)
		return 1;
	else if(windowHeight >= documentHeight && windowWidth < documentWidth)
		return 2;
	else {
		return 0;
	}
}

function removeAutoScrollMarker() {
	if (_autoScrollMarkerImage != null)
		_autoScrollMarkerImage.parentNode.removeChild(_autoScrollMarkerImage);

	if (_overlayContainer != null)
		_overlayContainer.parentNode.removeChild(_overlayContainer);
	
	_overlayContainer = null;
	_autoScrollMarkerImage = null;
}
